-----------------------------------------------------
---  PFC M Rosa Prats Vidal
-----------------------------------------------------
---  Creaci del package per el manteniment de taules
---  Creaci de procediments i funcions del package
-----------------------------------------------------


CREATE OR REPLACE PACKAGE  admsecur.pkgManteniment AS

-- declaraci de Procedures i Functions	

-- paisos
   PROCEDURE AltaPais (p_nompais  IN pais.nompais%TYPE,
                       RES        OUT VARCHAR2);
   PROCEDURE BaixaPais (p_idpais  IN pais.idpais%TYPE,
						RES       OUT VARCHAR2);
   PROCEDURE ModifPais (p_idpais  IN pais.idpais%TYPE,
						p_nompais IN pais.nompais%TYPE,
						RES       OUT VARCHAR2);  
   FUNCTION CercarIdPais(p_nomPais pais.nompais%TYPE) 
   RETURN pais.idpais%TYPE;

-- tipus incidencia 
   PROCEDURE AltaTipusInc (p_nomtipusinc  IN tipusinc.nomtipusinc%TYPE,
						   RES         	  OUT VARCHAR2);
   PROCEDURE BaixaTipusInc (p_idtipusinc  IN tipusinc.idtipusinc%TYPE,
							RES       	  OUT VARCHAR2);
   PROCEDURE ModifTipusInc (p_idtipusinc  IN tipusinc.idtipusinc%TYPE,
							p_nomtipusinc IN tipusinc.nomtipusinc%TYPE,
							RES       	  OUT VARCHAR2);			  
   FUNCTION CercarIdTipusInc(p_nomtipusinc tipusinc.nomtipusinc%TYPE) 
   RETURN tipusinc.idtipusinc%TYPE;   

-- poblacions
   PROCEDURE AltaPoblacio (p_nompoblacio IN poblacio.nompoblacio%TYPE,
						   p_idpais		 IN poblacio.idpais%TYPE,
						   RES           OUT VARCHAR2);  					   
   PROCEDURE BaixaPoblacio (p_idpoblacio IN poblacio.idpoblacio%TYPE,
							RES        	 OUT VARCHAR2);
   PROCEDURE ModifPoblacio (p_idpoblacio IN poblacio.idpoblacio%TYPE,
							p_nompoblacio IN poblacio.nompoblacio%TYPE,
							p_idpais	 IN poblacio.idpais%TYPE,
						    RES          OUT VARCHAR2);   							
   FUNCTION CercarIdPoblacio(p_nompoblacio poblacio.nompoblacio%TYPE) 
   RETURN poblacio.idpoblacio%TYPE;

-- empreses
  PROCEDURE AltaEmpresa (p_nomempresa 		IN empresa.nomempresa%TYPE,
						 p_nif  			IN empresa.nif%TYPE,
						 p_adrea  			IN empresa.adrea%TYPE,
						 p_idpoblacio		IN empresa.idpoblacio%TYPE,
						 p_codipostal		IN empresa.codipostal%TYPE,
						 p_telefon1			IN empresa.telefon1%TYPE,
						 p_fax				IN empresa.fax%TYPE,
						 p_email			IN empresa.email%TYPE,
						 RES 				OUT VARCHAR2);					 
  PROCEDURE BaixaEmpresa (p_idempresa 		IN empresa.idempresa%TYPE,
						 RES     			OUT VARCHAR2);											
  PROCEDURE ModifEmpresa (p_idempresa 		IN empresa.idempresa%TYPE,
							p_nomempresa 	IN empresa.nomempresa%TYPE,
							p_nif  			IN empresa.nif%TYPE,
							p_adrea  		IN empresa.adrea%TYPE,
							p_idpoblacio	IN empresa.idpoblacio%TYPE,
							p_codipostal	IN empresa.codipostal%TYPE,
							p_telefon1		IN empresa.telefon1%TYPE,
							p_fax			IN empresa.fax%TYPE,
							p_email			IN empresa.email%TYPE,
							RES 			OUT VARCHAR2);						
  FUNCTION CercarIdEmpresa(p_nif empresa.nif%TYPE) 
  RETURN empresa.idempresa%TYPE;
   
-- edificis
  PROCEDURE AltaEdifici (p_nomedifici	IN edifici.nomedifici%TYPE,
						 p_idempresa	IN edifici.idempresa%TYPE,
						 p_adrea  		IN edifici.adrea%TYPE,
						 p_idpoblacio	IN edifici.idpoblacio%TYPE,
						 p_codipostal	IN edifici.codipostal%TYPE,
						 p_telefon		IN edifici.telefon%TYPE,
						 p_mail			IN edifici.mail%TYPE,
						 RES 			OUT VARCHAR2);
  PROCEDURE BaixaEdifici (p_idedifici 	IN edifici.idedifici%TYPE,
						 RES     		OUT VARCHAR2);	
  FUNCTION CercarIdEdifici(p_nomedifici edifici.nomedifici%TYPE) 
  RETURN edifici.idedifici%TYPE;

-- departaments
  PROCEDURE Altadepartament (p_nomdepartament IN departament.nomdepartament%TYPE,
						     p_idedifici	  IN departament.idedifici%TYPE,
						     RES              OUT VARCHAR2);  	
  PROCEDURE Baixadepartament (p_iddepartament IN departament.iddepartament%TYPE,
                              RES             OUT VARCHAR2);
  FUNCTION CercarIdDepartament(p_nomdepartament departament.nomdepartament%TYPE, p_idedifici departament.idedifici%TYPE) 
  RETURN departament.iddepartament%TYPE;

-- incidencies
  PROCEDURE AltaIncidencies (p_idedifici	  IN incidencies.idedifici%TYPE,
							 p_idtipusinc     IN incidencies.idtipusinc%TYPE,
						     p_iddepartament  IN incidencies.iddepartament%TYPE,
						     p_descincidencia IN incidencies.descincidencia%TYPE,
						     RES              OUT VARCHAR2);  

-- permisos
  PROCEDURE AltaPermisos (p_idnivell  		IN permisos.idnivell%TYPE,
						  p_iddepartament 	IN permisos.iddepartament%TYPE,
						  p_idedifici	 	IN permisos.idedifici%TYPE,						  
  					      RES               OUT VARCHAR2); 					 
							 
-- personal
  PROCEDURE AltaPersonal (p_idedifici	  	IN personal.idedifici%TYPE,
						  p_idempresa     	IN personal.idempresa%TYPE,
						  p_iddepartament  	IN personal.iddepartament%TYPE,
						  p_nif 		  	IN personal.nif%TYPE,
						  p_nom 			IN personal.nom%TYPE,
						  p_sexe 			IN personal.sexe%TYPE,
						  p_data_naixement 	IN personal.data_naixement%TYPE,
						  p_nivell 			IN personal.nivell%TYPE,
						  p_activat 		IN personal.activat%TYPE,							 
						  RES               OUT VARCHAR2);  

  FUNCTION CercarIdPersonal(p_nif personal.nif%TYPE) 
  RETURN personal.idpersonal%TYPE;

-- accesos 
 PROCEDURE AltaAcces  (p_idedifici	  	IN acces.idedifici%TYPE,
						p_iddepartament IN acces.iddepartament%TYPE,
						p_nif 		  	IN acces.nif%TYPE,
						p_estat			IN acces.estat%TYPE,
						RES             OUT VARCHAR2);   
  
-- visitants
  PROCEDURE AltaVisitant (p_idvisitant		IN visitant.idvisitant%TYPE,
						  p_idedifici	  	IN visitant.idedifici%TYPE,
						  p_nif 		  	IN visitant.nif%TYPE,
						  p_nom 			IN visitant.nom%TYPE,
						  p_sexe 			IN visitant.sexe%TYPE,
						  p_data_naixement 	IN visitant.data_naixement%TYPE,
						  p_nivell 			IN visitant.nivell%TYPE,
						  p_activat 		IN visitant.activat%TYPE,							 
						  RES               OUT VARCHAR2);  
  FUNCTION CercarIdVisitant(p_nif visitant.nif%TYPE) 
  RETURN visitant.idVisitant%TYPE;

-- visites

 PROCEDURE Altavisites ( p_idvisita 		IN visites.idvisita%TYPE,
						  p_idvisitant 		IN visites.idvisitant%TYPE,
						  p_idpersonal		IN visites.idpersonal%TYPE,
						  p_idedifici	  	IN visites.idedifici%TYPE,
						  p_iddepartament  	IN visites.iddepartament%TYPE, 
						  RES               OUT VARCHAR2);  

						  
-- paquets
  PROCEDURE AltaPaquets (p_idedifici	IN paquet.idedifici%TYPE,
						 p_idpersonal  	IN paquet.idpersonal%TYPE,
						 p_iddepartament IN paquet.iddepartament%TYPE,
						 p_observacions	IN paquet.observacions%TYPE,
						 RES             OUT VARCHAR2); 

END;
/

-----------------------------------------------------
---  Cos del Package Manteniment
-----------------------------------------------------
CREATE OR REPLACE
PACKAGE BODY admsecur.pkgManteniment AS

-----------------------------------------------------
---  Paisos
-----------------------------------------------------
  FUNCTION CercarIdPais(p_nomPais pais.nompais%TYPE) 
   RETURN pais.idpais%TYPE

  IS
	idAux pais.idpais%TYPE; 
	q INTEGER;
  BEGIN

	  SELECT count(*) as d  
	  INTO q
	  FROM pais
	  WHERE p_nompais = nompais;

	  IF (q > 0) THEN
		  SELECT idpais 
			INTO idAux
		  FROM pais
		  WHERE p_nompais = nompais;
		  RETURN idAux;
	  ELSE 
		  RETURN 0;  --si no existeix retorna 0
	  END IF;
  END;
--------------------------------------------------------------------
-- AltaPais
-------------
  PROCEDURE AltaPais (p_nompais  IN pais.nompais%TYPE,
                      RES        OUT VARCHAR2)
  IS
   E_CAMP_NUL         EXCEPTION;
   E_pais_EXISTEIX    EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'P_NOMpais: '||p_nompais;
	 --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_nompais) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que el registre no s'hagi inserit previament
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM pais
        WHERE nompais  = p_nompais
          AND ROWNUM  = 1;
        RAISE E_pais_EXISTEIX;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
      END;
      --Si ha passat les proves de validaci realitza la inserci
      INSERT INTO pais (nompais)
           VALUES (p_nompais);
      RES := 'OK'; 
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.AltaPais', param_entrada, 'RES: '||RES);
      COMMIT;

  EXCEPTION
    WHEN E_pais_EXISTEIX THEN
      RES := 'ERROR: el pais ja ha estat donada d alta';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPais', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPais', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPais', param_entrada, 'RES: '||RES);
      COMMIT;
  END;
---------------------------------------------------------------------------------------------
 -- baixa Pais 
 -------------
  PROCEDURE BaixaPais (p_idpais  IN pais.idpais%TYPE,
                       RES       OUT VARCHAR2)
  IS
   E_CAMP_NUL  EXCEPTION;
   E_pais_NOEXISTEIX EXCEPTION;
   E_pais_JA_BAIXA EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
      param_entrada := 'P_idpais: '||p_idpais;
      --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_idpais) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que la pais existeix en la Base de Dades
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM pais
        WHERE idpais = p_idpais
          AND ROWNUM   = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_pais_NOEXISTEIX;
      END;
      --Verifica que el pais no est donada de baixa
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM pais
        WHERE idpais = p_idpais
          AND dataBaixa  IS NULL
          AND ROWNUM   = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_pais_JA_BAIXA;
      END;
      --Si ha passat les proves de validaci realitza l'esborrat lgic de la pais
      UPDATE pais SET dataBaixa = SYSDATE
      WHERE  idpais = p_idpais;
      RES := 'OK';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.BaixaPais', param_entrada, 'RES: '||RES);
      COMMIT;

   EXCEPTION
      WHEN E_pais_NOEXISTEIX THEN
        RES := 'ERROR: El pais a donar de baixa no existeix en la base de dades';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaPais', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN E_pais_JA_BAIXA THEN
        RES := 'ERROR: El pais ja havia estat donada de baixa';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaPais', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp ID del pais no pot ser nul';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaPais', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaPais', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
---------------------------------------------------------------------------------------------
 -- modificacio de Pais 
 ----------------------- 

 PROCEDURE ModifPais (p_idpais   IN pais.idpais%TYPE,
					  p_nompais  IN pais.nompais%TYPE,
					  RES        OUT VARCHAR2)
  IS
   E_CAMP_NUL          EXCEPTION;
   E_pais_NOEXISTEIX   EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'P_idpais: '||p_idpais||', P_nompais: '||p_nompais;
      --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_idpais) IS NULL) OR (TRIM(p_nompais) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que la pais existeix en la Base de Dades
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM pais
        WHERE idpais = p_idpais
          AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_pais_NOEXISTEIX;
      END; 
     --Si es passen les proves de validaci actualiza
     UPDATE pais
        SET  nompais = nvl(p_nompais, nompais)
      WHERE   idpais = p_idpais;
      commit;
     RES:= 'OK';
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.ModifPais', param_entrada, 'RES: '||RES);
     COMMIT;
 
    EXCEPTION
      WHEN E_pais_NOEXISTEIX THEN
        RES := 'ERROR: L identificador del pais a modificar no existeix';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifPais', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: L identificador del pais no pot ser nul';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifPais', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifPais', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
 
----------------------------------------------------------------------------------------------
-----------------------------------------------------
---  Tipus Incidencia
-----------------------------------------------------
FUNCTION CercarIdTipusInc(p_nomtipusinc tipusinc.nomtipusinc%TYPE) 
   RETURN tipusinc.idtipusinc%TYPE   

  IS
	idAux tipusinc.idtipusinc%TYPE; 
	q INTEGER;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM tipusinc
	  WHERE p_nomtipusinc = nomtipusinc;

	  IF (q > 0) THEN
		  SELECT idtipusinc
			INTO idAux
		  FROM tipusinc
		  WHERE p_nomtipusinc = nomtipusinc;
		  RETURN idAux;
	  ELSE 
		  RETURN 0;  --si no existeix retorna 0
	  END IF;
  END; 
--------------------------------------------------------------------
-- Alta Tipus Incidencia
------------------------
  PROCEDURE AltaTipusInc (p_nomtipusinc  IN tipusinc.nomtipusinc%TYPE,
                          RES            OUT VARCHAR2)
  IS
   E_CAMP_NUL          EXCEPTION;
   E_tipusinc_EXISTEIX EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_nomtipusinc: '||p_nomtipusinc;
	 --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_nomtipusinc) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que el registre no s'hagi inserit previament
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM tipusinc
        WHERE nomtipusinc  = p_nomtipusinc
          AND ROWNUM  = 1;
        RAISE E_tipusinc_EXISTEIX;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
      END;
      --Si ha passat les proves de validaci realitza la inserci
      INSERT INTO tipusinc (nomtipusinc)
           VALUES (p_nomtipusinc);
      RES := 'OK';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.AltaTipusInc', param_entrada, 'RES: '||RES);
      COMMIT;
  EXCEPTION
    WHEN E_tipusinc_EXISTEIX THEN
      RES := 'ERROR: el Tipus Incidencia ja ha estat donada d alta';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaTipusInc', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaTipusInc', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaTipusInc', param_entrada, 'RES: '||RES);
      COMMIT;
  END;
---------------------------------------------------------------------------------------------
 -- baixa Tipus Incidencia 
 -------------------------
  PROCEDURE BaixaTipusInc (p_idtipusinc  IN tipusinc.idtipusinc%TYPE,
                           RES           OUT VARCHAR2)
  IS
   E_CAMP_NUL  			 EXCEPTION;
   E_tipusinc_NOEXISTEIX EXCEPTION;
   E_tipusinc_JA_BAIXA   EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
      param_entrada := 'p_idtipusinc: '||p_idtipusinc;
      --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_idtipusinc) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que el tipusinc existeix en la Base de Dades
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM tipusinc
        WHERE idtipusinc = p_idtipusinc
          AND ROWNUM   = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_tipusinc_NOEXISTEIX;
      END;
      --Verifica que el tipusinc no est donada de baixa
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM tipusinc
        WHERE idtipusinc = p_idtipusinc
          AND dataBaixa  IS NULL
          AND ROWNUM   = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_tipusinc_JA_BAIXA;
      END;
      --Si ha passat les proves de validaci realitza l'esborrat lgic del tipusinc
      UPDATE tipusinc SET dataBaixa = SYSDATE
      WHERE  idtipusinc = p_idtipusinc;
      RES := 'OK';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.BaixaTipusInc', param_entrada, 'RES: '||RES);
      COMMIT;

    EXCEPTION
      WHEN E_tipusinc_NOEXISTEIX THEN
        RES := 'ERROR: El tipusinc a donar de baixa no existeix en la base de dades';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaTipusInc', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN E_tipusinc_JA_BAIXA THEN
        RES := 'ERROR: El tipusinc ja havia estat donada de baixa';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaTipusInc', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp ID del tipusinc no pot ser nul';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaTipusInc', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaTipusInc', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
---------------------------------------------------------------------------------------------
 -- modificacio de Tipus Incidencia 
 ---------------------------- 
 PROCEDURE ModifTipusInc (p_idtipusinc  IN tipusinc.idtipusinc%TYPE,
					        p_nomtipusinc IN tipusinc.nomtipusinc%TYPE,
					        RES           OUT VARCHAR2)
  IS
   E_CAMP_NUL             EXCEPTION;
   E_tipusinc_NOEXISTEIX  EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_idtipusinc: '||p_idtipusinc||', p_nomtipusinc: '||p_nomtipusinc;
      --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_idtipusinc) IS NULL) OR (TRIM(p_nomtipusinc) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que la tipusinc existeix en la Base de Dades
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM tipusinc
        WHERE idtipusinc = p_idtipusinc
          AND ROWNUM   = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_tipusinc_NOEXISTEIX;
      END;
     --Si es passen les proves de validaci actualiza
     UPDATE tipusinc
        SET  nomtipusinc = nvl(p_nomtipusinc, nomtipusinc)
      WHERE   idtipusinc = p_idtipusinc;
      commit;
     RES:= 'OK';
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.ModifTipusInc', param_entrada, 'RES: '||RES);
     COMMIT;

   EXCEPTION
      WHEN E_tipusinc_NOEXISTEIX THEN
        RES := 'ERROR: L identificador del tipus incidencia a modificar no existeix';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifTipusInc', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: L identificador del tipus incidencia no pot ser nul';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifTipusInc', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifTipusInc', param_entrada, 'RES: '||RES);
        COMMIT;
  END; 

 ---------------------------------------------------------------------------------------------
 ---------------------------------------------------------------------------------------------
 -- Poblacions
 ---------------------------- 
  FUNCTION CercarIdPoblacio(p_nompoblacio poblacio.nompoblacio%TYPE) 
  RETURN POBLACIO.idpoblacio%TYPE
  IS
	idAux POBLACIO.idpoblacio%TYPE; 
	q INTEGER;
  BEGIN

	  SELECT count(*) as d  
	  INTO q
	  FROM POBLACIO
	  WHERE p_nomPoblacio = nomPoblacio;

	  IF (q > 0) THEN
		  SELECT idpoblacio 
			INTO idAux
		  FROM POBLACIO
		  WHERE p_nomPoblacio = nomPoblacio;
		  RETURN idAux;
	  ELSE 
		  RETURN 0;  --si no existeix retorna 0
	  END IF;
  END;
  
 ---------------------------------------------------------------------------------------------
 -- alta de Poblacions
 ---------------------------- 
  PROCEDURE AltaPoblacio (p_nompoblacio IN poblacio.nompoblacio%TYPE,
						  p_idpais		IN poblacio.idpais%TYPE,
						  RES           OUT VARCHAR2)  
  IS
   E_CAMP_NUL          EXCEPTION;
   E_POBLACIO_EXISTEIX EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_nompoblacio: '||p_nompoblacio||', p_idpais: '||p_idpais;
	 --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_nompoblacio) IS NULL) OR (TRIM(p_idpais) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que el registre no s'hagi inserit previament
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM poblacio
        WHERE nompoblacio  = p_nompoblacio
          AND ROWNUM  = 1;
        RAISE E_poblacio_EXISTEIX;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
      END;
      --Si ha passat les proves de validaci realitza la inserci
      INSERT INTO poblacio (nompoblacio,idpais)
           VALUES (p_nompoblacio,p_idpais);
      RES := 'OK';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.AltaPoblacio', param_entrada, 'RES: '||RES);
      COMMIT;
  EXCEPTION
    WHEN E_poblacio_EXISTEIX THEN
      RES := 'ERROR: La poblacio ja ha estat donada d alta';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPoblacio', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPoblacio', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPoblacio', param_entrada, 'RES: '||RES);
      COMMIT;
  END;

---------------------------------------------------------------------------------------------
 -- baixa Poblacio 
 -------------------------
  PROCEDURE BaixaPoblacio (p_idpoblacio  IN poblacio.idpoblacio%TYPE,
                           RES           OUT VARCHAR2)
  IS
   E_CAMP_NUL  			 EXCEPTION;
   E_poblacio_NOEXISTEIX EXCEPTION;
   E_poblacio_JA_BAIXA   EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
      param_entrada := 'p_idpoblacio: '||p_idpoblacio;
      --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_idpoblacio) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que la poblacio existeix en la Base de Dades
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM poblacio
        WHERE idpoblacio = p_idpoblacio
          AND ROWNUM   = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_poblacio_NOEXISTEIX;
      END;
      --Verifica que la poblacio no est donada de baixa
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM poblacio
        WHERE idpoblacio = p_idpoblacio
          AND dataBaixa  IS NULL
          AND ROWNUM   = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_poblacio_JA_BAIXA;
      END;
      --Si ha passat les proves de validaci realitza l'esborrat lgic de la poblacio
      UPDATE poblacio SET dataBaixa = SYSDATE
      WHERE  idpoblacio = p_idpoblacio;
      RES := 'OK';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.BaixaPoblacio', param_entrada, 'RES: '||RES);
      COMMIT;

   EXCEPTION
      WHEN E_poblacio_NOEXISTEIX THEN
        RES := 'ERROR: La poblacio a donar de baixa no existeix en la base de dades';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaPoblacio', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN E_poblacio_JA_BAIXA THEN
        RES := 'ERROR: La poblacio ja havia estat donada de baixa';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaPoblacio', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp ID de la poblacio no pot ser nul';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaPoblacio', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaPoblacio', param_entrada, 'RES: '||RES);
        COMMIT;
  END;

  ---------------------------------------------------------------------------------------------
 -- modificacio de Poblacions
 ---------------------------- 
 PROCEDURE ModifPoblacio (p_idpoblacio  IN poblacio.idpoblacio%TYPE,
					      p_nompoblacio IN poblacio.nompoblacio%TYPE,
						  p_idpais		IN poblacio.idpais%TYPE,
						  RES           OUT VARCHAR2)
  IS
   E_CAMP_NUL             EXCEPTION;
   E_Poblacio_NOEXISTEIX  EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_idPoblacio: '||p_idpoblacio||', p_nomPoblacio: '||p_nompoblacio||', p_idpais: '||p_idpais;

	--Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_idpoblacio) IS NULL) OR (TRIM(p_nompoblacio) IS NULL) OR (TRIM(p_idpais) IS NULL) 
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que la Poblacio existeix en la Base de Dades
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM poblacio
        WHERE idpoblacio = p_idpoblacio
          AND ROWNUM   = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_Poblacio_NOEXISTEIX;
      END;
     --Si es passen les proves de validaci actualiza
     UPDATE Poblacio
        SET  nompoblacio = nvl(p_nompoblacio, nompoblacio),   			
			 idpais = nvl(p_idpais, idpais)
      WHERE   idpoblacio = p_idpoblacio;
      commit;
     RES:= 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.ModifPoblacio', param_entrada, 'RES: '||RES);
     COMMIT;

   EXCEPTION
      WHEN E_Poblacio_NOEXISTEIX THEN
        RES := 'ERROR: L identificador de la poblacio a modificar no existeix';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifPoblacio', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: L identificador de la poblacio no pot ser nul';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifPoblacio', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifPoblacio', param_entrada, 'RES: '||RES);
        COMMIT;
END; 
 
 -------------------------------------------------------------------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Empreses
 ---------------------------- 
 FUNCTION CercarIdEmpresa(p_nif empresa.nif%TYPE) 
  RETURN empresa.idempresa%TYPE
    IS
	idAux empresa.idempresa%TYPE; 
	q INTEGER;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM empresa
	  WHERE p_nif = nif;

	  IF (q > 0) THEN
		  SELECT idempresa 
			INTO idAux
		  FROM empresa
		  WHERE p_nif = nif;
		  RETURN idAux;
	  ELSE 
		  RETURN 0;  --si no existeix retorna 0
	  END IF;
  END;
  
 ---------------------------------------------------------------------------------------------
 -- Alta d'Empreses
 ----------------------------  
  PROCEDURE AltaEmpresa (p_nomempresa 	IN empresa.nomempresa%TYPE,
						 p_nif  		IN empresa.nif%TYPE,
						 p_adrea  		IN empresa.adrea%TYPE,
						 p_idpoblacio	IN empresa.idpoblacio%TYPE,
						 p_codipostal	IN empresa.codipostal%TYPE,
						 p_telefon1		IN empresa.telefon1%TYPE,
						 p_fax			IN empresa.fax%TYPE,
						 p_email		IN empresa.email%TYPE,
						 RES 			OUT VARCHAR2)
  IS						
   E_CAMP_NUL         	  EXCEPTION;
   E_EMPRESA_EXISTEIX     EXCEPTION;
   E_poblacio_NOEXISTEIX  EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'P_NOMEMPRESA: '||p_nomEmpresa||', P_NIF: '||p_nif||', P_ADREA: '||p_adrea||', P_IDPOBLACIO: '||p_idpoblacio||', P_CODIPOSTAL: '||p_codipostal||', P_TELEFON1: '||p_telefon1||', P_eMAIL: '||p_email;
     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_nomEmpresa) IS NULL) OR (TRIM(p_nif) IS NULL) OR (TRIM(p_adrea) IS NULL)  
				OR (TRIM(p_idpoblacio) IS NULL) OR (TRIM(p_telefon1) IS NULL)
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;
     --Verifica que el registre no s'hagi inserit previament
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE nif  = p_nif
			  AND ROWNUM  = 1;
        RAISE E_EMPRESA_EXISTEIX;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
     END;
	  --Verifica que la poblacio existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM POBLACIO
        WHERE idpoblacio  = p_idpoblacio
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_poblacio_NOEXISTEIX;
      END;	 
     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO EMPRESA (nomEmpresa,nif,adrea,idpoblacio,codipostal,telefon1,fax,email)
          VALUES (p_nomEmpresa,p_nif,p_adrea,p_idpoblacio,p_codipostal,p_telefon1,p_fax,p_email);
     RES := 'OK';
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'pkgManteniment.AltaEmpresa', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_EMPRESA_EXISTEIX THEN
      RES := 'ERROR: l empresa ja ha estat donada d alta';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaEmpresa', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaEmpresa', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_poblacio_NOEXISTEIX  THEN
      RES := 'ERROR: La poblacio no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaEmpresa', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaEmpresa', param_entrada, 'RES: '||RES);
      COMMIT;
  END;

 ---------------------------------------------------------------------------------------------
 -- Baixa d'Empreses
 ----------------------------
  PROCEDURE BaixaEmpresa (p_idempresa 	IN EMPRESA.idempresa%TYPE,
						  RES     		OUT VARCHAR2)
  IS			
   E_CAMP_NUL  EXCEPTION;
   E_EMPRESA_NOEXISTEIX EXCEPTION;
   E_EMPRESA_JA_BAIXA EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
      param_entrada := 'P_IDEMPRESA: '||p_idempresa;
     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idempresa) IS NULL) 
			THEN
				RAISE E_CAMP_NUL ;
     END IF;
     --Verifica que l empresa existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE idempresa = p_idempresa
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EMPRESA_NOEXISTEIX;
     END;
     --Verifica que l empresa no est donada de baixa
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE idempresa = p_idempresa
			AND dataBaixa  IS NULL
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EMPRESA_JA_BAIXA;
     END;
     --Si ha passat les proves de validaci realitza l'esborrat lgic de l empresa
     UPDATE EMPRESA SET dataBaixa = SYSDATE
     WHERE  idempresa = p_idempresa;
     RES := 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'pkgManteniment.BaixaEmpresa', param_entrada, 'RES: '||RES);
     COMMIT;

	 EXCEPTION
      WHEN E_EMPRESA_NOEXISTEIX THEN
        RES := 'ERROR: L empresa a donar de baixa no existeix en la base de dades';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaEmpresa', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_EMPRESA_JA_BAIXA THEN
        RES := 'ERROR: L empresa ja havia estat donada de baixa';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaEmpresa', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaEmpresa', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaEmpresa', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
 
 ---------------------------------------------------------------------------------------------
 -- Modificaci d'Empreses
 ----------------------------							
  PROCEDURE ModifEmpresa (p_idempresa 		IN empresa.idempresa%TYPE,
							p_nomempresa 		IN empresa.nomempresa%TYPE,
							p_nif  				IN empresa.nif%TYPE,
							p_adrea  			IN empresa.adrea%TYPE,
							p_idpoblacio		IN empresa.idpoblacio%TYPE,
							p_codipostal		IN empresa.codipostal%TYPE,
							p_telefon1			IN empresa.telefon1%TYPE,
							p_fax				IN empresa.fax%TYPE,
							p_email				IN empresa.email%TYPE,
							RES 				OUT VARCHAR2)
  IS
   E_CAMP_NUL             EXCEPTION;
   E_EMPRESA_NOEXISTEIX       EXCEPTION;
   E_poblacio_NOEXISTEIX  EXCEPTION;

   existeix        VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

   BEGIN

     param_entrada := 'P_IDEMPRESA: '||p_idempresa||'P_NOMEMPRESA: '||p_nomEmpresa||', P_NIF: '||p_nif||', P_ADREA: '||p_adrea||', P_IDPOBLACIO: '||p_idpoblacio||', P_CODIPOSTAL: '||p_codipostal||', P_TELEFON1: '||p_telefon1||', P_FAX: '||p_fax||', P_eMAIL: '||p_email;

     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idempresa) IS NULL) OR (TRIM(p_nomEmpresa) IS NULL) OR (TRIM(p_nif) IS NULL) 
			OR (TRIM(p_adrea) IS NULL) OR (TRIM(p_idpoblacio) IS NULL) OR (TRIM(p_telefon1) IS NULL)
				THEN 
					RAISE E_CAMP_NUL ;
     END IF;
     --Verifica que l empresa existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM EMPRESA
        WHERE idempresa = p_idempresa
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_EMPRESA_NOEXISTEIX;
     END;
	  --Verifica que la poblacio existeix en la base de dades
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM POBLACIO
        WHERE idpoblacio  = p_idpoblacio
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_poblacio_NOEXISTEIX;
      END;	
    
     --Si es passen les proves de validaci actualitzem
     UPDATE EMPRESA
        SET nomEmpresa = nvl(p_nomEmpresa, nomEmpresa),
			nif = nvl(p_nif, nif),
			adrea = nvl(p_adrea, adrea),
			idpoblacio = nvl(p_idpoblacio, idpoblacio),
			codipostal = nvl(p_codipostal, codipostal),
			telefon1 = nvl(p_telefon1, telefon1),
            fax  = nvl(p_fax, fax),
			email = nvl(p_email, email)
     WHERE  idempresa = p_idempresa;
    COMMIT;

     RES:= 'OK';
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.ModifEmpresa', param_entrada, 'RES: '||RES);
     COMMIT;

   EXCEPTION
      WHEN E_EMPRESA_NOEXISTEIX THEN
        RES := 'ERROR: L empresa a modificar no existeix';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifEmpresa', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';

        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifEmpresa', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_poblacio_NOEXISTEIX  THEN
        RES := 'ERROR: La poblacio no existeix en la base de dades';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifEmpresa', param_entrada, 'RES: '||RES);
        COMMIT;		
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.ModifEmpresa', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
 
 -------------------------------------------------------------------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Edificis
 ---------------------------- 
 FUNCTION CercarIdEdifici(p_nomedifici edifici.nomedifici%TYPE) 
  RETURN edifici.idedifici%TYPE
    IS
	idAux edifici.idedifici%TYPE; 
	q INTEGER;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM edifici
	  WHERE p_nomedifici = nomedifici;

	  IF (q > 0) THEN
		  SELECT idedifici 
			INTO idAux
		  FROM edifici
		  WHERE p_nomedifici = nomedifici;
		  RETURN idAux;
	  ELSE 
		  RETURN 0;  --si no existeix retorna 0
	  END IF;
  END;
  
 ---------------------------------------------------------------------------------------------
 -- Alta d'Edificis
 ----------------------------  
  PROCEDURE AltaEdifici (p_nomedifici	IN edifici.nomedifici%TYPE,
						 p_idempresa	IN edifici.idempresa%TYPE,
						 p_adrea  		IN edifici.adrea%TYPE,
						 p_idpoblacio	IN edifici.idpoblacio%TYPE,
						 p_codipostal	IN edifici.codipostal%TYPE,
						 p_telefon		IN edifici.telefon%TYPE,
						 p_mail			IN edifici.mail%TYPE,
						 RES 			OUT VARCHAR2)
  IS						
   E_CAMP_NUL         	  EXCEPTION;
   E_edifici_EXISTEIX     EXCEPTION;
   E_empresa_NOEXISTEIX   EXCEPTION;
   E_poblacio_NOEXISTEIX  EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'P_NOMedifici: '||p_nomedifici||', P_IdEmpresa: '||p_idempresa||', P_ADREA: '||p_adrea||', P_IDPOBLACIO: '||p_idpoblacio||', P_CODIPOSTAL: '||p_codipostal||', P_TELEFON: '||p_telefon||', P_eMAIL: '||p_mail;
     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_nomedifici) IS NULL) OR (TRIM(p_idempresa) IS NULL) OR (TRIM(p_adrea) IS NULL)  
				OR (TRIM(p_idpoblacio) IS NULL) OR (TRIM(p_telefon) IS NULL)
			THEN 
				RAISE E_CAMP_NUL ;
     END IF;
     --Verifica que el registre no s'hagi inserit previament
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM edifici
        WHERE nomedifici  = p_nomedifici
			  AND ROWNUM  = 1;
        RAISE E_edifici_EXISTEIX;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
     END;
	 --Verifica que la empressa existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM EMPRESA
        WHERE idempresa  = p_idempresa
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_poblacio_NOEXISTEIX;
      END;	 
	  --Verifica que la poblacio existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM POBLACIO
        WHERE idpoblacio  = p_idpoblacio
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_poblacio_NOEXISTEIX;
      END;	 
     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO edifici (nomedifici,idempresa,adrea,idpoblacio,codipostal,telefon,mail)
          VALUES (p_nomedifici,p_idempresa,p_adrea,p_idpoblacio,p_codipostal,p_telefon,p_mail);
     RES := 'OK';
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'pkgManteniment.AltaEdifici', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_edifici_EXISTEIX THEN
      RES := 'ERROR: l edifici ja ha estat donada d alta';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaEdifici', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaEdifici', param_entrada, 'RES: '||RES);
      COMMIT;
	WHEN E_empresa_NOEXISTEIX  THEN
      RES := 'ERROR: L empresa no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaEdifici', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_poblacio_NOEXISTEIX  THEN
      RES := 'ERROR: La poblacio no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaEdifici', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaEdifici', param_entrada, 'RES: '||RES);
      COMMIT;
  END;

 ---------------------------------------------------------------------------------------------
 -- Baixa d'Edificis
 ---------------------------- 
  PROCEDURE BaixaEdifici (p_idedifici 	IN edifici.idedifici%TYPE,
						 RES     		OUT VARCHAR2)
   IS			
   E_CAMP_NUL  EXCEPTION;
   E_Edifici_NOEXISTEIX EXCEPTION;
   E_Edifici_JA_BAIXA EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
      param_entrada := 'P_IDEdifici: '||p_idEdifici;
     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idEdifici) IS NULL) 
			THEN
				RAISE E_CAMP_NUL ;
     END IF;
     --Verifica que l Edifici existeix en la Base de Dades
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM Edifici
        WHERE idEdifici = p_idEdifici
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_Edifici_NOEXISTEIX;
     END;
     --Verifica que l Edifici no est donada de baixa
     BEGIN
		SELECT 'S'
        INTO EXISTEIX
        FROM Edifici
        WHERE idEdifici = p_idEdifici
			AND dataBaixa  IS NULL
			AND ROWNUM   = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_Edifici_JA_BAIXA;
     END;
     --Si ha passat les proves de validaci realitza l'esborrat lgic de l Edifici
     UPDATE Edifici SET dataBaixa = SYSDATE
     WHERE  idEdifici = p_idEdifici;
     RES := 'OK';

     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'pkgManteniment.BaixaEdifici', param_entrada, 'RES: '||RES);
     COMMIT;

	 EXCEPTION
      WHEN E_Edifici_NOEXISTEIX THEN
        RES := 'ERROR: L Edifici a donar de baixa no existeix en la base de dades';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaEdifici', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_Edifici_JA_BAIXA THEN
        RES := 'ERROR: L Edifici ja havia estat donada de baixa';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaEdifici', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp no pot ser nul';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaEdifici', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.BaixaEdifici', param_entrada, 'RES: '||RES);
        COMMIT;
  END;

 -------------------------------------------------------------------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Departaments
 ---------------------------- 
 FUNCTION CercarIdDepartament(p_nomdepartament departament.nomdepartament%TYPE, p_idedifici departament.idedifici%TYPE) 
  RETURN departament.iddepartament%TYPE

  IS
	idAux departament.iddepartament%TYPE; 
	q INTEGER;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM departament
	  WHERE p_nomdepartament = nomdepartament
	  AND p_idedifici = idedifici;

	  IF (q > 0) THEN
		  SELECT iddepartament 
			INTO idAux
		  FROM departament
		  WHERE p_nomdepartament = nomdepartament
		  AND p_idedifici = idedifici;
		  RETURN idAux;
	  ELSE 
		  RETURN 0;  --si no existeix retorna 0
	  END IF;
  END;

 ---------------------------------------------------------------------------------------------
 -- Alta departaments
 ---------------------------- 
  PROCEDURE AltaDepartament (p_nomdepartament IN departament.nomdepartament%TYPE,
						     p_idedifici	  IN departament.idedifici%TYPE,
						     RES              OUT VARCHAR2)  					   
  IS
   E_CAMP_NUL          EXCEPTION;
   E_departament_EXISTEIX EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_nomdepartament: '||p_nomdepartament||', p_idedifici: '||p_idedifici;
	 --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_nomdepartament) IS NULL) OR (TRIM(p_idedifici) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que el registre no s'hagi inserit previament
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM departament
        WHERE nomdepartament  = p_nomdepartament
		  AND idedifici  = p_idedifici	   
          AND ROWNUM  = 1;
        RAISE E_departament_EXISTEIX;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
      END;
      --Si ha passat les proves de validaci realitza la inserci
      INSERT INTO departament (nomdepartament,idedifici)
           VALUES (p_nomdepartament,p_idedifici);
      RES := 'OK';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.AltaDepartament', param_entrada, 'RES: '||RES);
      COMMIT;
  EXCEPTION
    WHEN E_departament_EXISTEIX THEN
      RES := 'ERROR: El departament ja ha estat donada d alta';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaDepartament', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaDepartament', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaDepartament', param_entrada, 'RES: '||RES);
      COMMIT;
  END;

---------------------------------------------------------------------------------------------
 -- baixa departament 
 -------------------------
  PROCEDURE Baixadepartament (p_iddepartament  IN departament.iddepartament%TYPE,
                              RES           OUT VARCHAR2)
  IS
   E_CAMP_NUL  			    EXCEPTION;
   E_departament_NOEXISTEIX EXCEPTION;
   E_departament_JA_BAIXA   EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
      param_entrada := 'p_iddepartament: '||p_iddepartament;
      --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_iddepartament) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
      --Verifica que la departament existeix en la Base de Dades
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM departament
        WHERE iddepartament = p_iddepartament
          AND ROWNUM   = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_departament_NOEXISTEIX;
      END;
      --Verifica que la departament no est donada de baixa
      BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM departament
        WHERE iddepartament = p_iddepartament
          AND dataBaixa  IS NULL
          AND ROWNUM   = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_departament_JA_BAIXA;
      END;
      --Si ha passat les proves de validaci realitza l'esborrat lgic de la departament
      UPDATE departament SET dataBaixa = SYSDATE
      WHERE  iddepartament = p_iddepartament;
      RES := 'OK';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.Baixadepartament', param_entrada, 'RES: '||RES);
      COMMIT;

   EXCEPTION
      WHEN E_departament_NOEXISTEIX THEN
        RES := 'ERROR: El departament a donar de baixa no existeix en la base de dades';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.Baixadepartament', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN E_departament_JA_BAIXA THEN
        RES := 'ERROR: El departament ja havia estat donada de baixa';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.Baixadepartament', param_entrada, 'RES: '||RES);
        COMMIT;
      WHEN E_CAMP_NUL  THEN
        RES := 'ERROR: El camp ID de la departament no pot ser nul';
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.Baixadepartament', param_entrada, 'RES: '||RES);
        COMMIT;
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
        INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE, 'pkgManteniment.Baixadepartament', param_entrada, 'RES: '||RES);
        COMMIT;
  END;
 
 -------------------------------------------------------------------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Incidncies
 ---------------------------- 
  ---------------------------------------------------------------------------------------------
 -- Alta Incidncies
 ---------------------------- 
   PROCEDURE AltaIncidencies (p_idedifici	  IN incidencies.idedifici%TYPE,
							 p_idtipusinc     IN incidencies.idtipusinc%TYPE,
						     p_iddepartament  IN incidencies.iddepartament%TYPE,
						     p_descincidencia IN incidencies.descincidencia%TYPE,
						     RES              OUT VARCHAR2)
  IS
   E_CAMP_NUL    EXCEPTION;
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_idedifici: '||p_idedifici||', p_idtipusinc: '||p_idtipusinc||', p_iddepartament: '||p_iddepartament||', p_descincidencia: '||p_descincidencia;
	 --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_idedifici) IS NULL) OR (TRIM(p_idtipusinc) IS NULL) OR (TRIM(p_iddepartament) IS NULL) OR (TRIM(p_descincidencia) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
    --Si ha passat les proves de validaci realitza la inserci
      INSERT INTO incidencies (idedifici, idtipusinc, iddepartament, descincidencia)
           VALUES (p_idedifici, p_idtipusinc, p_iddepartament, p_descincidencia);
      RES := 'OK';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.AltaIncidencies', param_entrada, 'RES: '||RES);
      COMMIT;
  EXCEPTION
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaIncidencies', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaIncidencies', param_entrada, 'RES: '||RES);
      COMMIT;
  END; 

 -------------------------------------------------------------------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Permisos
 ---------------------------- 
  PROCEDURE AltaPermisos (p_idnivell  		IN permisos.idnivell%TYPE,
						  p_iddepartament 	IN permisos.iddepartament%TYPE,
						  p_idedifici	 	IN permisos.idedifici%TYPE,	
  					      RES               OUT VARCHAR2)
   IS
   E_CAMP_NUL    			EXCEPTION;
   E_departament_NOEXISTEIX EXCEPTION;
   E_edifici_NOEXISTEIX  	EXCEPTION;

   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_idnivell: '||p_idnivell||', p_iddepartament: '||p_iddepartament||', p_idedifici: '||p_idedifici;
	 --Verifica que tots els camps obligatoris tenen valor
      IF (TRIM(p_idnivell) IS NULL) OR (TRIM(p_iddepartament) IS NULL) OR (TRIM(p_idedifici) IS NULL)
		THEN
			RAISE E_CAMP_NUL ;
      END IF;
	 --Verifica que el departament existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM departament
        WHERE iddepartament = p_iddepartament
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_departament_NOEXISTEIX;
      END;		  
	 --Verifica que l'edifici existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM edifici
        WHERE idedifici = p_idedifici
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_edifici_NOEXISTEIX;
      END;		
  --Si ha passat les proves de validaci realitza la inserci
      INSERT INTO permisos (idnivell, iddepartament, idedifici)
           VALUES (p_idnivell, p_iddepartament, p_idedifici);
      RES := 'OK';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
           VALUES(SYSDATE,'pkgManteniment.AltaPermisos', param_entrada, 'RES: '||RES);
      COMMIT;
  EXCEPTION
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPermisos', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_departament_NOEXISTEIX  THEN
      RES := 'ERROR: El depatament no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPermisos', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_edifici_NOEXISTEIX  THEN
      RES := 'ERROR: L edifici no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPermisos', param_entrada, 'RES: '||RES);
      COMMIT;
	  WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPermisos', param_entrada, 'RES: '||RES);
      COMMIT;
  END; 

 -------------------------------------------------------------------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Personal
 ---------------------------- 
 FUNCTION CercarIdpersonal(p_nif personal.nif%TYPE) 
  RETURN personal.idpersonal%TYPE
    IS
	idAux personal.idpersonal%TYPE; 
	q INTEGER;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM personal
	  WHERE p_nif = nif;

	  IF (q > 0) THEN
		  SELECT idpersonal 
			INTO idAux
		  FROM personal
		  WHERE p_nif = nif;
		  RETURN idAux;
	  ELSE 
		  RETURN 0;  --si no existeix retorna 0
	  END IF;
  END; 

---------------------------------------------------------------------------------------------
 -- Alta Personal
 ----------------------------   
  PROCEDURE AltaPersonal (p_idedifici	  	IN personal.idedifici%TYPE,
						  p_idempresa     	IN personal.idempresa%TYPE,
						  p_iddepartament  	IN personal.iddepartament%TYPE,
						  p_nif 		  	IN personal.nif%TYPE,
						  p_nom 			IN personal.nom%TYPE,
						  p_sexe 			IN personal.sexe%TYPE,
						  p_data_naixement 	IN personal.data_naixement%TYPE,
						  p_nivell 			IN personal.nivell%TYPE,
						  p_activat 		IN personal.activat%TYPE,							 
						  RES               OUT VARCHAR2) 
  IS						
   E_CAMP_NUL         	 EXCEPTION;
   E_personal_EXISTEIX   EXCEPTION;
   E_edifici_NOEXISTEIX  EXCEPTION;
   E_empresa_NOEXISTEIX  EXCEPTION;
   E_nivell_NOEXISTEIX   EXCEPTION;
   
   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_idedifici: '||p_idedifici||',p_idempresa: '||p_idempresa||',p_iddepartament:'||p_iddepartament||',p_nif:'||p_nif ||',p_nom:'||p_nom||',p_sexe:'||p_sexe||',p_data_naixement:'||p_data_naixement||',p_nivell:'||p_nivell||',p_activat:'||p_activat;
     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idedifici) IS NULL) OR (TRIM(p_idempresa) IS NULL) OR (TRIM(p_iddepartament) IS NULL) OR (TRIM(p_nif) IS NULL) OR (TRIM(p_nom) IS NULL) 
				OR (TRIM(p_sexe) IS NULL) OR (TRIM(p_data_naixement) IS NULL) OR (TRIM(p_nivell) IS NULL) OR (TRIM(p_activat) IS NULL)
			THEN 
				RAISE E_CAMP_NUL;
     END IF;
     --Verifica que el registre no s'hagi inserit previament
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM personal
        WHERE nif  = p_nif
			  AND ROWNUM  = 1;
        RAISE E_personal_EXISTEIX;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
     END;
	 --Verifica que l edifici existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM edifici
        WHERE idedifici  = p_idedifici
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_edifici_NOEXISTEIX;
      END;	
	 --Verifica que l empresa existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM empresa
        WHERE idempresa  = p_idempresa
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_empresa_NOEXISTEIX;
      END;	
	 --Verifica que el nivell existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM permisos
        WHERE idnivell  = p_nivell
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_nivell_NOEXISTEIX;
      END;		  
     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO personal (idedifici,idempresa,iddepartament,nif,nom,sexe,data_naixement,nivell,activat)
          VALUES (p_idedifici,p_idempresa,p_iddepartament,p_nif,p_nom,p_sexe,p_data_naixement,p_nivell,p_activat);
     RES := 'OK';
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'pkgManteniment.Altapersonal', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_personal_EXISTEIX THEN
      RES := 'ERROR: l personal ja ha estat donada d alta';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPersonal', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPersonal', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_edifici_NOEXISTEIX  THEN
      RES := 'ERROR: La edifici no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPersonal', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_empresa_NOEXISTEIX  THEN
      RES := 'ERROR: La empresa no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPersonal', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_nivell_NOEXISTEIX  THEN
      RES := 'ERROR: El nivell no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPersonal', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPersonal', param_entrada, 'RES: '||RES);
      COMMIT;
  END;

 -------------------------------------------------------------------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Visitants
 ---------------------------- 
 ---------------------------------------------------------------------------------------------

 FUNCTION CercarIdVisitant(p_nif Visitant.nif%TYPE) 
  RETURN Visitant.idVisitant%TYPE
    IS
	idAux Visitant.idVisitant%TYPE; 
	q INTEGER;
  BEGIN
	  SELECT count(*) as d  
	  INTO q
	  FROM Visitant
	  WHERE p_nif = nif;

	  IF (q > 0) THEN
		  SELECT idVisitant 
			INTO idAux
		  FROM Visitant
		  WHERE p_nif = nif;
		  RETURN idAux;
	  ELSE 
		  RETURN 0;  --si no existeix retorna 0
	  END IF;
  END; 
  -------------------------------------------------
 -- Alta visitants
 ----------------------------  
 PROCEDURE AltaVisitant (p_idvisitant		IN visitant.idvisitant%TYPE,
						  p_idedifici	  	IN visitant.idedifici%TYPE,
						  p_nif 		  	IN visitant.nif%TYPE,
						  p_nom 			IN visitant.nom%TYPE,
						  p_sexe 			IN visitant.sexe%TYPE,
						  p_data_naixement 	IN visitant.data_naixement%TYPE,
						  p_nivell 			IN visitant.nivell%TYPE,
						  p_activat 		IN visitant.activat%TYPE,							 
						  RES               OUT VARCHAR2)
   IS						
   E_CAMP_NUL         	 EXCEPTION;
   E_visitant_EXISTEIX   EXCEPTION;
   E_edifici_NOEXISTEIX  EXCEPTION;
   E_nivell_NOEXISTEIX   EXCEPTION;
   
   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_idedifici: '||p_idedifici||',p_nif:'||p_nif ||',p_nom:'||p_nom||',p_sexe:'||p_sexe||',p_data_naixement:'||p_data_naixement||',p_nivell:'||p_nivell||',p_activat:'||p_activat;
     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idedifici) IS NULL) OR (TRIM(p_nif) IS NULL) OR (TRIM(p_nom) IS NULL) OR (TRIM(p_sexe) IS NULL) 
				OR (TRIM(p_data_naixement) IS NULL) OR (TRIM(p_nivell) IS NULL) OR (TRIM(p_activat) IS NULL)
			THEN 
				RAISE E_CAMP_NUL;
     END IF;
     --Verifica que el registre no s'hagi inserit previament
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM visitant
        WHERE nif  = p_nif
			  AND ROWNUM  = 1;
        RAISE E_visitant_EXISTEIX;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           NULL;
     END;
	 --Verifica que l edifici existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM edifici
        WHERE idedifici  = p_idedifici
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_edifici_NOEXISTEIX;
      END;	
	 --Verifica que el nivell existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM permisos
        WHERE idnivell  = p_nivell
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_nivell_NOEXISTEIX;
      END;		  
     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO visitant (idedifici,nif,nom,sexe,data_naixement,nivell,activat)
          VALUES (p_idedifici,p_nif,p_nom,p_sexe,p_data_naixement,p_nivell,p_activat);
     RES := 'OK';
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'pkgManteniment.AltaVisitant', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_Visitant_EXISTEIX THEN
      RES := 'ERROR: El Visitant ja ha estat donada d alta';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisitant', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisitant', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_edifici_NOEXISTEIX  THEN
      RES := 'ERROR: L edifici no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisitant', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_nivell_NOEXISTEIX  THEN
      RES := 'ERROR: El nivell no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisitant', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisitant', param_entrada, 'RES: '||RES);
      COMMIT;
  END;			  
						  
 -------------------------------------------------------------------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Visites
 ---------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Alta visites
 ---------------------------- 
 
  PROCEDURE AltaVisites ( p_idvisita 		IN visites.idvisita%TYPE,
						  p_idvisitant 		IN visites.idvisitant%TYPE,
						  p_idpersonal		IN visites.idpersonal%TYPE,
						  p_idedifici	  	IN visites.idedifici%TYPE,
						  p_iddepartament  	IN visites.iddepartament%TYPE, 
						  RES               OUT VARCHAR2)
   IS						
   E_CAMP_NUL         	 EXCEPTION;
   E_visitant_EXISTEIX   EXCEPTION;
   E_personal_NOEXISTEIX EXCEPTION;
   E_edifici_NOEXISTEIX  EXCEPTION;
   E_departament_NOEXISTEIX  EXCEPTION; 
 
   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_idVisitant: '||p_idVisitant||',p_idpersonal:'||p_idpersonal ||',p_idedifici:'||p_idedifici||',p_iddepartament:'||p_iddepartament;
     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idvisitant) IS NULL) OR (TRIM(p_idpersonal) IS NULL) OR (TRIM(p_idedifici) IS NULL) OR (TRIM(p_iddepartament) IS NULL) 
			THEN 
				RAISE E_CAMP_NUL;
     END IF;
	 --Verifica que el visitant ja existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM visitant
        WHERE idvisitant  = p_idvisitant
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_visitant_EXISTEIX;
      END;	
	 --Verifica que la persona existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM personal
        WHERE idpersonal  = p_idpersonal
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_personal_NOEXISTEIX;
      END;	
	 --Verifica que l edifici existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM edifici
        WHERE idedifici  = p_idedifici
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_edifici_NOEXISTEIX;
      END;		
	 --Verifica que el departament existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM departament
        WHERE iddepartament  = p_iddepartament
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_departament_NOEXISTEIX;
      END;		  
     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO Visites (idvisitant,idpersonal,idedifici,iddepartament)
          VALUES (p_idvisitant,p_idpersonal,p_idedifici,p_iddepartament);
     RES := 'OK';
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'pkgManteniment.AltaVisites', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisites', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_Visitant_EXISTEIX THEN
      RES := 'ERROR: El Visitant ja ha estat donada d alta';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisites', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_Personal_NOEXISTEIX THEN
      RES := 'ERROR: La persona no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisites', param_entrada, 'RES: '||RES);
      COMMIT;
   WHEN E_edifici_NOEXISTEIX  THEN
      RES := 'ERROR: L edifici no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisites', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_departament_NOEXISTEIX  THEN
      RES := 'ERROR: El departament no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisites', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaVisites', param_entrada, 'RES: '||RES);
      COMMIT;
 END;
 
 -------------------------------------------------------------------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Acessos
 ---------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Alta accessos
 ----------------------------   
  PROCEDURE AltaAcces  (p_idedifici	  	IN Acces.idedifici%TYPE,
						p_iddepartament IN Acces.iddepartament%TYPE,
						p_nif 		  	IN Acces.nif%TYPE,
						p_estat			IN Acces.estat%TYPE,
						RES             OUT VARCHAR2)  
  IS						
   E_CAMP_NUL         	 EXCEPTION;
   E_edifici_NOEXISTEIX  EXCEPTION;
   E_departament_NOEXISTEIX  EXCEPTION;
   E_nif_NOEXISTEIX  		 EXCEPTION;
   
   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_idedifici: '||p_idedifici||',p_iddepartament:'||p_iddepartament||',p_nif:'||p_nif ||',p_estat:'||p_estat;
     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idedifici) IS NULL) OR (TRIM(p_iddepartament) IS NULL) OR (TRIM(p_nif) IS NULL) OR (TRIM(p_estat) IS NULL) 
			THEN 
				RAISE E_CAMP_NUL;
     END IF;
     --Verifica que el nif existeixi, i que esta actiu a la base de dades
     BEGIN
        SELECT 'S'
        INTO EXISTEIX
        FROM (select a.nif, a.nivell, b.idedifici, b.iddepartament 
			  from personal a, permisos b
			  WHERE a.nif  = p_nif
				AND a.nivell= b.idnivell
				AND a.activat = 'S'
				AND b.idedifici = p_idedifici
				AND b.iddepartament = p_iddepartament)
		WHERE ROWNUM  = 1;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        RAISE E_nif_NOEXISTEIX;
     END;
	 --Verifica que l edifici existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM edifici
        WHERE idedifici  = p_idedifici
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_edifici_NOEXISTEIX;
      END;	
	 --Verifica que el departament existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM departament
        WHERE iddepartament  = p_iddepartament
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_departament_NOEXISTEIX;
      END;	
     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO Acces (idedifici,iddepartament,nif,estat)
          VALUES (p_idedifici,p_iddepartament,p_nif,p_estat);
     RES := 'OK';
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'pkgManteniment.AltaAcces', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_nif_NOEXISTEIX THEN
      RES := 'ERROR: el nif no existeix, o no te permis per accedir';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaAcces', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaAcces', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_edifici_NOEXISTEIX  THEN
      RES := 'ERROR: L edifici no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaAcces', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_departament_NOEXISTEIX  THEN
      RES := 'ERROR: El departament no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaAcces', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaAcces', param_entrada, 'RES: '||RES);
      COMMIT;
  END;

 -------------------------------------------------------------------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Paquets
 ---------------------------- 
 ---------------------------------------------------------------------------------------------
 -- Alta paquet
 ----------------------------  
 
  PROCEDURE AltaPaquets (p_idedifici	IN paquet.idedifici%TYPE,
						 p_idpersonal  	IN paquet.idpersonal%TYPE,
						 p_iddepartament IN paquet.iddepartament%TYPE,
						 p_observacions	IN paquet.observacions%TYPE,
						 RES             OUT VARCHAR2) 
   IS						
   E_CAMP_NUL         	 EXCEPTION;
   E_personal_NOEXISTEIX   EXCEPTION;
   E_edifici_NOEXISTEIX  EXCEPTION;
   E_departament_NOEXISTEIX  EXCEPTION;
  
   existeix      VARCHAR2(1);
   param_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

  BEGIN
     param_entrada := 'p_idedifici: '||p_idedifici||',p_idpersonal: '||p_idpersonal||',p_iddepartament:'||p_iddepartament||',p_obervacions:'||p_observacions;
     --Verifica que tots els camps obligatoris tenen valor
     IF (TRIM(p_idedifici) IS NULL) OR (TRIM(p_idpersonal) IS NULL) OR (TRIM(p_iddepartament) IS NULL) OR (TRIM(p_observacions) IS NULL) 
			THEN 
				RAISE E_CAMP_NUL;
     END IF;
	 --Verifica que l edifici existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM edifici
        WHERE idedifici  = p_idedifici
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_edifici_NOEXISTEIX;
      END;	
	 --Verifica que el departament existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM departament
        WHERE iddepartament  = p_iddepartament
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_departament_NOEXISTEIX;
      END;	
	 --Verifica que el destinatari existeix en la base de dades
     BEGIN
       SELECT 'S'
         INTO EXISTEIX
         FROM personal
        WHERE idpersonal  = p_idpersonal
          AND ROWNUM  = 1;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_personal_NOEXISTEIX;
      END;		  
     --Si ha passat les proves de validaci realitza la inserci
     INSERT INTO paquet (idedifici,idpersonal,iddepartament,observacions)
          VALUES (p_idedifici,p_idpersonal,p_iddepartament,p_observacions);
     RES := 'OK';
     INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
          VALUES(SYSDATE,'pkgManteniment.AltaPaquet', param_entrada, 'RES: '||RES);
     COMMIT;

  EXCEPTION
    WHEN E_CAMP_NUL  THEN
      RES := 'ERROR: El camp no pot ser nul';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPaquet', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_edifici_NOEXISTEIX  THEN
      RES := 'ERROR: L edifici no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPaquet', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_departament_NOEXISTEIX  THEN
      RES := 'ERROR: El departament no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPaquet', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN E_personal_NOEXISTEIX  THEN
      RES := 'ERROR: El destinatari no existeix en la base de dades';
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPaquet', param_entrada, 'RES: '||RES);
      COMMIT;
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RES:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO LOGS (dataLog, PROCEDIMENT, PARAMSENTRADA, PARAMSSORTIDA)
         VALUES(SYSDATE, 'pkgManteniment.AltaPaquet', param_entrada, 'RES: '||RES);
      COMMIT;
  END;
---------------------------------------------------------------------------------------------------
						 
END;
/
COMMIT;

